/* SoriBada - compatible client with windows soribada
 * Copyright (C) 2002 Choe Hwanjin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

/* search tab */
void on_search_entry_activated (GtkEditable *editable, gpointer data);
void on_search_button_clicked(GtkButton *button, gpointer data);
void on_stop_button_clicked(GtkButton *button, gpointer data);
void on_search_in_result_button_toggled(GtkToggleButton *togglebutton, gpointer data);
void on_search_clist_select_row(GtkWidget *clist, gint row, gint colum, GdkEventButton *event, gpointer data);
void on_search_clist_menu_download_activate(GtkMenuItem *menuitem, gpointer data);
void on_search_clist_menu_download_as_activate(GtkMenuItem *menuitem, gpointer data);
void on_search_clist_menu_download_queue_activate(GtkMenuItem *menuitem, gpointer data);
void on_search_clist_menu_delete_activate(GtkMenuItem *menuitem, gpointer data);
void on_search_clist_menu_message_activate(GtkMenuItem *menuitem, gpointer data);
void on_search_clist_click_column(GtkWidget *clist, gint column, gpointer data);
gboolean on_search_clist_button_press(GtkWidget *widget, GdkEvent *event, gpointer data);

/* download tab */
void on_downloading_clist_menu_stop_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_pause_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_resume_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_queueing_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_play_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_remove_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_delete_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloading_clist_menu_message_activate(GtkMenuItem *menuitem, gpointer data);
gboolean on_downloading_clist_button_press(GtkWidget *widget, GdkEvent *event, gpointer data);

void on_downloaded_clist_menu_play_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloaded_clist_menu_file_info_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloaded_clist_menu_remove_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloaded_clist_menu_delete_activate(GtkMenuItem *menuitem, gpointer data);
void on_downloaded_clist_menu_message_activate(GtkMenuItem *menuitem, gpointer data);

/* upload tab */
void on_upload_clist_menu_message_activate(GtkMenuItem *menuitem, gpointer data);

/* local file tab */
void on_add_button_clicked(GtkButton *button, gpointer data);
void on_delete_button_clicked(GtkButton *button, gpointer data);
void on_scan_button_clicked (GtkButton *button, gpointer data);
void on_delete_all_button_clicked (GtkButton *button, gpointer data);
void on_stop_playing_button_clicked (GtkButton *button, gpointer data);
void on_local_clist_click_column(GtkWidget *clist, gint column, gpointer data);
/* menu */
void on_local_clist_menu_play_activate(GtkMenuItem *menuitem, gpointer data);
void on_local_clist_menu_file_info_activate(GtkMenuItem *menuitem, gpointer data);
void on_local_clist_menu_remove_activate(GtkMenuItem *menuitem, gpointer data);
void on_local_clist_menu_delete_activate(GtkMenuItem *menuitem, gpointer data);

/* menu popup for clists */
gboolean on_clist_button_press(GtkWidget *widget, GdkEvent *event, gpointer data);

void on_clist_select_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data);
void on_clist_unselect_row(GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer data);

/* main window */
gboolean on_window_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data);
gboolean on_window_destroy_event(GtkWidget *widget, GdkEvent *event, gpointer data);

/* menu callback */
void on_file_activate(GtkMenuItem *menuitem, gpointer data);
void on_connect_to_server_activate(GtkMenuItem *menuitem, gpointer data);
void on_disconnect_activate(GtkMenuItem *menuitem, gpointer data);
void on_help_activate(GtkMenuItem *menuitem, gpointer data);
void on_about_activate(GtkMenuItem *menuitem, gpointer data);
void on_quit_activate(GtkMenuItem *menuitem, gpointer data);
void on_soribada_activate(GtkMenuItem *menuitem, gpointer data);
void on_menu_message_activate (GtkMenuItem *menuitem, gpointer data);
void on_preference_activate(GtkMenuItem *menuitem, gpointer data);

/* login window */
void on_login_username_entry_activated (GtkEditable *enditable, gpointer data);
void on_login_password_entry_activated (GtkEditable *enditable, gpointer data);
void on_login_connect_button_clicked (GtkButton *button, gpointer data);
void on_login_cancel_button_clicked (GtkButton *button, gpointer data);

/* alert window */
void on_alert_destroy (GtkWidget *widget, gpointer data);
void on_alert_ok_button_clicked (GtkButton *button, gpointer data);

/* preference window */
void on_preference_window_destroy (GtkObject *object, gpointer user_data);
void on_check_button_toggled(GtkToggleButton *togglebutton, gpointer data);
void on_save_username_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_save_password_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_default_server_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_use_proxy_server_toggled (GtkToggleButton *togglebutton, gpointer data);

void on_download_dir_button_clicked (GtkButton *button, gpointer user_data);
void on_mp3player_button_clicked (GtkButton *button, gpointer user_data);
void on_local_mp3_dir_button_clicked (GtkButton *button, gpointer data);
void on_local_mp3_dir_add_button_clicked (GtkButton *button, gpointer data);
void on_local_mp3_dir_delete_button_clicked (GtkButton *button, gpointer data);
void on_use_bandwidth_button_toggled (GtkToggleButton *togglebutton, gpointer data);
void on_sound_device_menu_activated (GtkMenuItem *menuitem, gpointer data);
void on_sound_event_clist_selected (GtkCList *clist, gint row, gint col, GdkEventButton *event, gpointer data);
void on_sound_event_clist_unselected (GtkCList *clist, gint row, gint col, GdkEventButton *event, gpointer data);
gboolean on_sound_event_clist_button_press (GtkWidget *widget, GdkEventButton *event, gpointer data);
void on_sound_test_button_clicked (GtkButton *button, gpointer data);
void on_sound_modify_button_clicked (GtkButton *button, gpointer data);
void on_select_sound_dlg_ok (GtkButton *button, gpointer data);
void on_select_sound_dlg_cancel (GtkButton *button, gpointer data);

gboolean on_preferences_spinbutton_event (GtkWidget *widget, GdkEventExpose *event, gpointer data);
gboolean on_preferences_entry_event (GtkWidget *widget, GdkEventExpose *event, gpointer data);

void on_preference_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_preference_cancel_button_clicked (GtkButton *button, gpointer user_data);

void on_download_as_ok_clicked (GtkButton *button, gpointer data);
void on_download_as_cancel_clicked (GtkButton *button, gpointer data);

void on_file_add_dlg_ok_button_clicked (GtkButton *button, gpointer data);
void on_file_add_dlg_cancel_button_clicked (GtkButton *button, gpointer data);

void on_select_download_dir_dlg_ok (GtkButton *button, gpointer data);
void on_select_download_dir_dlg_cancel (GtkButton *button, gpointer data);

void on_select_mp3player_dlg_ok (GtkButton *button, gpointer data);
void on_select_mp3player_dlg_cancel (GtkButton *button, gpointer data);

void on_select_local_mp3_dir_dlg_ok (GtkButton *button, gpointer data);
void on_select_local_mp3_dir_dlg_cancel (GtkButton *button, gpointer data);

void on_file_add_dlg_ok (GtkButton *button, gpointer data);
void on_file_add_dlg_cancel (GtkButton *button, gpointer data);

void on_about_button_clicked (GtkButton *button, gpointer data);

/* file info window */
void on_use_id3_tag_button_toggled(GtkToggleButton *togglebutton, gpointer data);
void on_file_info_genre_selected(GtkList *list, GtkWidget *widget, gpointer data);
void on_file_info_entry_changed(GtkEditable *editable, gpointer data);
void on_file_info_save_button_clicked (GtkButton *button, gpointer data);
void on_file_info_rename_button_clicked (GtkWidget *widget, gpointer data);
void on_file_info_close_button_clicked (GtkButton *button, gpointer data);

/* message window */
void on_message_window_close_button_clicked (GtkButton *button, gpointer data);
void on_message_clist_menu_reply_activate(GtkButton *menuitem, gpointer data);
void on_message_clist_menu_delete_activate(GtkButton *menuitem, gpointer data);
void on_message_clist_select_row(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer data);
void on_message_send_button_clicked (GtkButton *button, gpointer data);
void on_message_close_button_clicked (GtkButton *button, gpointer data);

