/* SoriBada - compatible client with windows soribada
 * Copyright (C) 2002 Choe Hwanjin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "config.h"

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <time.h>
#include <stdlib.h>

#include "soribada.h"
#include "mp3.h"
#include "core.h"
#include "interface.h"
#include "callbacks.h"
#include "soribada.xpm"

GtkWidget *create_search_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Download"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_search_clist_menu_download_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Download as ..."));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_search_clist_menu_download_as_activate),
			(gpointer)widget);

	/*
	 *  queueing ޴ ְ  ȶ download
	 * ϵ Ѵ
	menuitem = gtk_menu_item_new_with_label(_("Queueing"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_search_clist_menu_download_queue_activate),
			(gpointer)widget);
	*/

	menuitem = gtk_menu_item_new_with_label(_("Delete"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_search_clist_menu_delete_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Message..."));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_search_clist_menu_message_activate),
			(gpointer)widget);

	return menu;
}

GtkWidget *create_search_tab(void) {
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *entry;
	GtkWidget *hbuttonbox;
	GtkWidget *search_button;
	GtkWidget *stop_button;
	GtkWidget *checkbutton;
	GtkWidget *scrolledwindow;
	GtkWidget *clist;
	GtkWidget *menu;

	vbox = gtk_vbox_new (FALSE, 5);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	hbox = gtk_hbox_new (FALSE, 10);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

	label = gtk_label_new (_("Keyword"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

	entry = gtk_entry_new_with_max_length (30);
	gtk_widget_show (entry);
	gtk_box_pack_start (GTK_BOX (hbox), entry, FALSE, FALSE, 0);
	app->search_entry = entry;
	gtk_signal_connect (GTK_OBJECT (entry), "activate",
		      GTK_SIGNAL_FUNC (on_search_entry_activated),
		      entry);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start (GTK_BOX (hbox), hbuttonbox, FALSE, FALSE, 5);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_START);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox), 70, -2);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);

	search_button = gtk_button_new_with_label (_("Search"));
	gtk_widget_show (search_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), search_button);
	app->search_button = search_button;
	gtk_signal_connect (GTK_OBJECT (search_button), "clicked",
		      GTK_SIGNAL_FUNC (on_search_button_clicked),
		      entry);

	stop_button = gtk_button_new_with_label (_("Stop"));
	gtk_widget_show (stop_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), stop_button);

	checkbutton = gtk_check_button_new_with_label (_("search in result"));
	gtk_widget_show (checkbutton);
	gtk_box_pack_start (GTK_BOX (hbox), checkbutton, FALSE, FALSE, 0);

	hbox = gtk_hbox_new (FALSE, 10);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			    GTK_SIGNAL_FUNC(on_search_in_result_button_toggled),
			    hbox);

	label = gtk_label_new (_("Invert match:"));
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

	entry = gtk_entry_new_with_max_length (30);
	gtk_box_pack_start (GTK_BOX (hbox), entry, FALSE, FALSE, 0);
	app->search_inverse_entry = entry;

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (9);
	app->search_clist = clist;
	gtk_widget_show (clist);
	gtk_clist_set_selection_mode (GTK_CLIST (clist), GTK_SELECTION_EXTENDED);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	label = gtk_label_new (_("Title"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 1, \
					 app->search_clist_title);

	label = gtk_label_new (_("Artist"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 2, \
					 app->search_clist_artist);

	label = gtk_label_new (_("Comment"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 3, 80);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 3, \
					 app->search_clist_comment);

	label = gtk_label_new (_("Size"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 4, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 4, 80);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 4, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 4, \
					 app->search_clist_size);

	label = gtk_label_new (_("Bitrate"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 5, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 5, 40);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 5, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 5, \
					 app->search_clist_bitrate);

	label = gtk_label_new (_("Time"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 6, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 6, 50);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 6, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 6, \
					 app->search_clist_time);

	label = gtk_label_new (_("User"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 7, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 7, 60);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 7, \
					 app->search_clist_user);

	label = gtk_label_new (_("Speed"));
	gtk_widget_ref (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 8, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 8, 60);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 8, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 8, \
					 app->search_clist_speed);

	label = gtk_label_new (_("Filename"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 200);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 0, \
					 app->search_clist_filename);

	menu = create_search_clist_menu(clist);

	/* signals */
	gtk_signal_connect (GTK_OBJECT (stop_button), "clicked",
		      GTK_SIGNAL_FUNC (on_stop_button_clicked),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (clist), "select_row",
		      GTK_SIGNAL_FUNC (on_search_clist_select_row),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (clist), "click-column",
		      GTK_SIGNAL_FUNC (on_search_clist_click_column),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
		      GTK_SIGNAL_FUNC (on_search_clist_button_press),
		      menu);

	return vbox;
}

GtkWidget *create_downloading_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Resume"));
	app->downloading_clist_resume_menu = menuitem;
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_resume_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Pause"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_pause_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Stop"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_stop_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Queueing"));
	app->downloading_clist_queueing_menu = menuitem;
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_queueing_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("test play"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_play_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete from list"));
	//gtk_widget_set_sensitive(menuitem, FALSE);
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_remove_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete file"));
	//gtk_widget_set_sensitive(menuitem, FALSE);
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_delete_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Message..."));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloading_clist_menu_message_activate),
			(gpointer)widget);

	return menu;
}

GtkWidget *create_downloaded_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Play"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloaded_clist_menu_play_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("File info"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloaded_clist_menu_file_info_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete from list"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloaded_clist_menu_remove_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete file"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloaded_clist_menu_delete_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Message..."));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_downloaded_clist_menu_message_activate),
			(gpointer)widget);

	return menu;
}


GtkWidget *create_download_tab(void) {
	GtkWidget *vpaned;
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *scrolledwindow;
	GtkWidget *clist;
	GtkWidget *menu;

	vpaned = gtk_vpaned_new ();
	gtk_widget_show (vpaned);
	//gtk_paned_set_position (GTK_PANED (vpaned), 0);

	/* Downloading files - upper */
	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_paned_pack1 (GTK_PANED (vpaned), vbox, FALSE, TRUE);

	label = gtk_label_new (_("Downloading files"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0.1, 0.5);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (6);
	app->downloading_clist = clist;
	gtk_widget_show (clist);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 180);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 70);
	gtk_clist_set_column_width (GTK_CLIST (clist), 3, 70);
	gtk_clist_set_column_width (GTK_CLIST (clist), 4, 50);
	gtk_clist_set_column_width (GTK_CLIST (clist), 5, 60);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	label = gtk_label_new (_("User"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 1, \
					 app->downloading_clist_user);

	label = gtk_label_new (_("Size"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 2, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 2, \
					 app->downloading_clist_size);

	label = gtk_label_new (_("Received"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 3, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 3, \
					 app->downloading_clist_received);

	label = gtk_label_new (_("Speed"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 4, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 4, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 4, \
					 app->downloading_clist_speed);

	label = gtk_label_new (_("Progress"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 5, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 5, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 5, \
					 app->downloading_clist_progress);

	label = gtk_label_new (_("Filename"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 0, \
					 app->downloading_clist_filename);

	menu = create_downloading_clist_menu(clist);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
		      GTK_SIGNAL_FUNC (on_downloading_clist_button_press),
		      menu);

	/* Downloaded files - lower */
	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_paned_pack2 (GTK_PANED (vpaned), vbox, TRUE, TRUE);

	label = gtk_label_new (_("Downloaded files"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0.1, 0.5);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (5);
	app->downloaded_clist = clist;
	gtk_widget_show (clist);
	gtk_clist_set_selection_mode (GTK_CLIST (clist), GTK_SELECTION_EXTENDED);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 200);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);
	gtk_clist_set_column_width (GTK_CLIST (clist), 3, 80);
	gtk_clist_set_column_width (GTK_CLIST (clist), 4, 80);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	label = gtk_label_new (_("User"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 1, \
					 app->downloaded_clist_user);

	label = gtk_label_new (_("Size"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 2, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 2, \
					 app->downloaded_clist_size);

	label = gtk_label_new (_("Received"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 3, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 3, \
					 app->downloaded_clist_received);

	label = gtk_label_new (_("Status"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 4, label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 4, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 4, \
					 app->downloaded_clist_status);

	label = gtk_label_new (_("Filename"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);
	gtk_clist_set_column_visibility (GTK_CLIST (clist), 0, \
					 app->downloaded_clist_filename);

	/* clist ޴ */
	menu = create_downloaded_clist_menu(clist);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
		      GTK_SIGNAL_FUNC (on_clist_button_press),
		      menu);

	return vpaned;
}

GtkWidget *create_upload_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Message..."));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_upload_clist_menu_message_activate),
			(gpointer)widget);

	return menu;
}

GtkWidget *create_upload_tab(void) {
	GtkWidget *table;
	GtkWidget *clist;
	GtkWidget *label;
	GtkWidget *text;
	GtkWidget *menu;
	GtkWidget *scrolledwindow;

	table = gtk_table_new (2, 2, FALSE);
	gtk_widget_show (table);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 5);

	label = gtk_label_new (_("Uploading files"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0.05, 0.5);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_table_attach (GTK_TABLE (table), scrolledwindow, 0, 1, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (4);
	gtk_widget_show (clist);
	app->upload_clist = clist;
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 200);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 60);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 60);
	gtk_clist_set_column_width (GTK_CLIST (clist), 3, 60);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	menu = create_upload_clist_menu(clist);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
		      GTK_SIGNAL_FUNC (on_clist_button_press),
		      menu);

	label = gtk_label_new (_("Filename"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);

	label = gtk_label_new (_("User"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);

	label = gtk_label_new (_("Speed"));
	gtk_widget_show (label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 2, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);

	label = gtk_label_new (_("Progress"));
	gtk_widget_show (label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 3, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label);

	label = gtk_label_new (_("Received Queries"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 1, 2, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	text = gtk_text_new (NULL, NULL);
	gtk_widget_show (text);
	gtk_widget_set_usize (text, 120, -2);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_text_set_line_wrap(GTK_TEXT(text), FALSE);
	gtk_widget_set_sensitive(text, FALSE);
	gtk_table_attach (GTK_TABLE (table), text, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (GTK_FILL), 0, 0);
	app->query_text = text;

	return table;
}

GtkWidget *create_local_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Play"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_local_clist_menu_play_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("File info"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_local_clist_menu_file_info_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete from list"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_local_clist_menu_remove_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete file"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_local_clist_menu_delete_activate),
			(gpointer)widget);

	return menu;
}

GtkWidget *create_localfile_tab(void) {
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *scrolledwindow;
	GtkWidget *clist;
	GtkWidget *menu;
	GtkWidget *button;
	GtkWidget *add_button;
	GtkWidget *hbuttonbox;
	gchar *text[6];
	gint row;
	GList *list;

	vbox = gtk_vbox_new (FALSE, 5);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, FALSE, FALSE, 5);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_START);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox), -2, -2);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);

	add_button = gtk_button_new_with_label (_("Add file"));
	gtk_widget_show (add_button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), add_button);
	gtk_signal_connect (GTK_OBJECT (add_button), "clicked",
		      GTK_SIGNAL_FUNC (on_add_button_clicked),
		      NULL);

	/*
	button = gtk_button_new_with_label (_("Delete"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (on_delete_button_clicked),
		      NULL);
	*/

	button = gtk_button_new_with_label (_("Scan directory"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_scan_button_clicked),
			NULL);

	button = gtk_button_new_with_label (_("Delete all"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_delete_all_button_clicked),
			NULL);

	button = gtk_button_new_with_label (_("Stop playing"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_stop_playing_button_clicked),
			NULL);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (6);
	gtk_widget_show (clist);
	app->local_clist = clist;
	gtk_clist_set_selection_mode (GTK_CLIST (clist), GTK_SELECTION_EXTENDED);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	menu = create_local_clist_menu(clist);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
			    GTK_SIGNAL_FUNC (on_clist_button_press),
			    menu);

	label = gtk_label_new (_("Filename"));
	gtk_widget_show (label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 200);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);

	label = gtk_label_new (_("Title"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);

	label = gtk_label_new (_("Artist"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);

	label = gtk_label_new (_("Size"));
	gtk_widget_show (label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 3, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 3, 65);

	label = gtk_label_new (_("Bitrate"));
	gtk_widget_show (label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 4, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 4, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 4, 40);

	label = gtk_label_new (_("Time"));
	gtk_widget_show (label);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 5, GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 5, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 5, 40);

	list = app->mp3_list;
	while (list != NULL) {
		text[0] = g_basename(((MP3db *)(list->data))->realpath);
		text[1] = ((MP3db *)(list->data))->data->title;
		text[2] = ((MP3db *)(list->data))->data->artist;
		text[3] = ((MP3db *)(list->data))->data->size;
		text[4] = ((MP3db *)(list->data))->data->bitrate;
		text[5] = ((MP3db *)(list->data))->data->time;

		row = gtk_clist_append(GTK_CLIST(clist), text);
		gtk_clist_set_row_data(GTK_CLIST(clist), row, list->data);
		list = list->next;
	}

	gtk_signal_connect (GTK_OBJECT (clist), "click-column",
		      GTK_SIGNAL_FUNC (on_local_clist_click_column),
		      NULL);

	return vbox;
}

GtkWidget *create_notebook(void) {
	GtkWidget *notebook;
	GtkWidget *tab;
	GtkWidget *label;

	notebook = gtk_notebook_new ();
	gtk_widget_show (notebook);
	gtk_notebook_set_homogeneous_tabs(GTK_NOTEBOOK(notebook), TRUE);
	gtk_container_set_border_width (GTK_CONTAINER (notebook), 5);

	/* Search tab */
	tab = create_search_tab();
	gtk_widget_show (tab);
	label = gtk_label_new (_("Search"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* Downloading/Downloaded Files tab*/
	tab = create_download_tab();
	gtk_widget_show (tab);
	label = gtk_label_new (_("Download"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* Upload tab */
	tab = create_upload_tab();
	gtk_widget_show (tab);
	label = gtk_label_new (_("Upload"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* Local mp3 file tab */
	tab = create_localfile_tab();
	gtk_widget_show (tab);
	label = gtk_label_new (_("Local mp3 files"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	return notebook;
}

GtkWidget *create_menu_bar(GtkAccelGroup *accel_group) {
	GtkWidget *menubar;
	GtkWidget *file;
	GtkWidget *file_menu;
	GtkAccelGroup *file_menu_accels;
	GtkWidget *connect_to_server;
	GtkWidget *disconnect;
	GtkWidget *sep;
	GtkWidget *quit;
	GtkWidget *soribada;
	GtkWidget *soribada_menu;
	GtkAccelGroup *soribada_menu_accels;
	GtkWidget *option;
	GtkWidget *option_menu;
	GtkAccelGroup *option_menu_accels;
	GtkWidget *preference;
	GtkWidget *help;
	GtkWidget *help_menu;
	GtkAccelGroup *help_menu_accels;
	GtkWidget *about;
	GtkWidget *menuitem;

	menubar = gtk_menu_bar_new ();

	file = gtk_menu_item_new_with_label (_("File"));
	gtk_widget_show (file);
	gtk_container_add (GTK_CONTAINER (menubar), file);

	file_menu = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);
	file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu));

	connect_to_server = gtk_menu_item_new_with_label (_("Connect to server"));
	gtk_widget_show (connect_to_server);
	gtk_container_add (GTK_CONTAINER (file_menu), connect_to_server);
	app->menu_connect_to_server = connect_to_server;
	gtk_widget_add_accelerator(connect_to_server, "activate", accel_group, 
				   GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	disconnect = gtk_menu_item_new_with_label (_("Disconnect"));
	gtk_widget_show (disconnect);
	gtk_container_add (GTK_CONTAINER (file_menu), disconnect);
        gtk_widget_set_sensitive (disconnect, app->is_login);
	app->menu_disconnect = disconnect;
	gtk_widget_add_accelerator(disconnect, "activate", accel_group, 
				   GDK_D, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	sep = gtk_menu_item_new ();
	gtk_widget_show (sep);
	gtk_container_add (GTK_CONTAINER (file_menu), sep);

	quit = gtk_menu_item_new_with_label (_("Quit"));
	gtk_widget_show (quit);
	gtk_container_add (GTK_CONTAINER (file_menu), quit);
	gtk_widget_add_accelerator(quit, "activate", accel_group, 
				   GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	soribada = gtk_menu_item_new_with_label (_("Soribada"));
	gtk_widget_show (soribada);
	gtk_container_add (GTK_CONTAINER (menubar), soribada);

	soribada_menu = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (soribada), soribada_menu);
	soribada_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (soribada_menu));

	menuitem = gtk_menu_item_new_with_label (_("Message..."));
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (soribada_menu), menuitem);
	gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
		      GTK_SIGNAL_FUNC (on_menu_message_activate),
		      NULL);

	option = gtk_menu_item_new_with_label (_("Option"));
	gtk_widget_show (option);
	gtk_container_add (GTK_CONTAINER (menubar), option);

	option_menu = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (option), option_menu);
	option_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (option_menu));

	preference = gtk_menu_item_new_with_label (_("Preference ..."));
	gtk_widget_show (preference);
	gtk_container_add (GTK_CONTAINER (option_menu), preference);

	help = gtk_menu_item_new_with_label (_("Help"));
	gtk_widget_show (help);
	gtk_container_add (GTK_CONTAINER (menubar), help);

	help_menu = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (help), help_menu);
	help_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help_menu));

	about = gtk_menu_item_new_with_label (_("About ..."));
	gtk_widget_show (about);
	gtk_container_add (GTK_CONTAINER (help_menu), about);

	/* signals */
	gtk_signal_connect (GTK_OBJECT (connect_to_server), "activate",
		      GTK_SIGNAL_FUNC (on_connect_to_server_activate),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (disconnect), "activate",
		      GTK_SIGNAL_FUNC (on_disconnect_activate),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (quit), "activate",
		      GTK_SIGNAL_FUNC (on_quit_activate),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (soribada), "activate",
		      GTK_SIGNAL_FUNC (on_soribada_activate),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (preference), "activate",
		      GTK_SIGNAL_FUNC (on_preference_activate),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (about), "activate",
		      GTK_SIGNAL_FUNC (on_about_activate),
		      NULL);

	return menubar;
}

/*  progress_bar show_text option Ѹ  ũ⶧ 
 * Ʒ progress_bar ũⰡ Ŀ . ׷ progress_bar
 * ڸ ׸ Լ  . 
 *  Լ gtk/gtkprogressbar.c:gtk_progress_bar_paint() 
 * ̴ */
void gtk_progress_draw_text(GtkProgress *progress) {
	gint x, y;
	gfloat value;
	gchar text[64];
	GdkRectangle rect;
	GtkWidget *widget = GTK_WIDGET(progress);

	g_return_if_fail(progress->offscreen_pixmap != NULL);

	value = gtk_progress_get_value(progress);
	g_snprintf(text, sizeof(text), "%.0f", value);

	x = widget->style->klass->xthickness + 1 +
	   (widget->allocation.width - 2 * widget->style->klass->xthickness -
	    3 - gdk_text_width(widget->style->font, text, strlen(text)))
	   * progress->x_align;

	/*  y   . ׷ y    */
	y = widget->style->font->ascent + 1 +
	   (widget->allocation.height - 2 * widget->style->klass->ythickness -
	    1 - widget->style->font->ascent) * progress->y_align;

	rect.x = widget->style->klass->xthickness + 1;
	rect.y = widget->style->klass->ythickness + 1;
	/* width е 3ȼ  ݴ */
	rect.width = widget->allocation.width - 
		     2 * widget->style->klass->xthickness;
	rect.height = widget->allocation.height - 
		      2 * widget->style->klass->ythickness;

	gdk_gc_set_clip_rectangle(widget->style->fg_gc[widget->state], &rect);
	gdk_draw_text(progress->offscreen_pixmap, widget->style->font,
		      widget->style->fg_gc[widget->state],
		      x, y, text, strlen(text));
	gdk_gc_set_clip_rectangle(widget->style->fg_gc[widget->state], NULL);
	gtk_widget_queue_draw(GTK_WIDGET(progress));
}

GtkWidget* create_progress_bar(void) {
	GtkWidget *progressbar;

	progressbar = gtk_progress_bar_new();
	app->search_progressbar = progressbar;

	gtk_progress_configure(GTK_PROGRESS(progressbar), \
				0.0, 0.0, MAX_ONLINES);
	gtk_progress_set_show_text(GTK_PROGRESS(progressbar), FALSE);
	gtk_progress_set_format_string(GTK_PROGRESS(progressbar), "%v");
	gtk_progress_set_value(GTK_PROGRESS(progressbar), 0);
	gtk_widget_set_usize (progressbar, 150, -2);

	return progressbar;
}

GtkWidget* create_window(void) {
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *menubar;
	GtkWidget *notebook;
	GtkWidget *statusbar;
	GtkWidget *progressbar;
	GtkAccelGroup *accel_group;

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), _("SoriBada Client"));
	gtk_window_set_default_size (GTK_WINDOW (window), app->width, app->height);
	app->window = window;

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	/* menu */
	accel_group = gtk_accel_group_new();
	menubar = create_menu_bar(accel_group);
	gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, FALSE, 0);
	gtk_widget_show (menubar);
	gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);

	/* notebook */
	notebook = create_notebook();
	gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);

	/* statusbar */
	hbox = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

	statusbar = gtk_statusbar_new ();
	gtk_widget_show (statusbar);
	gtk_box_pack_start (GTK_BOX (hbox), statusbar, TRUE, TRUE, 0);
	app->statusbar = statusbar;
	app->context_id = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar),
						       "Search tab");

	progressbar = create_progress_bar();
	gtk_widget_show (progressbar);
	gtk_box_pack_start (GTK_BOX (hbox), progressbar, FALSE, FALSE, 0);

	/* signals */
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (on_window_delete_event),
		      NULL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy_event",
		      GTK_SIGNAL_FUNC (on_window_destroy_event),
		      NULL);

	return window;
}

GtkWidget *create_login_window (void) {
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *table;
	GtkWidget *entry;
	GtkWidget *button;
	/* guint x, y, w, h; */

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_container_set_border_width (GTK_CONTAINER (window), 3);
	gtk_window_set_title (GTK_WINDOW (window), _("Login SoriBada"));
	gtk_window_set_default_size (GTK_WINDOW (window), 160, 120);
	app->login_window = window;

	/* login window ġ  */
	/*
	gdk_window_get_size(app->window->window, &w, &h);
	gdk_window_get_root_origin(app->window->window, &x, &y);
	gtk_widget_set_uposition(window, x + w/2 - 160/2, y + h/2 - 120/2);
	*/

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	label = gtk_label_new (_("Connect to Soribada Server"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

	table = gtk_table_new (2, 2, TRUE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox), table, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 3);
	gtk_table_set_row_spacings (GTK_TABLE (table), 3);
	gtk_table_set_col_spacings (GTK_TABLE (table), 3);

	label = gtk_label_new (_("Username:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 3, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 10, 0);

	label = gtk_label_new (_("Password:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 3, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 10, 0);

	entry = gtk_entry_new ();
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 100, -2);
	app->username_entry = entry;
	if (app->username)
		gtk_entry_set_text(GTK_ENTRY(entry), app->username);
	gtk_signal_connect (GTK_OBJECT (entry), "activate",
			    GTK_SIGNAL_FUNC (on_login_username_entry_activated),
			    NULL);

	entry = gtk_entry_new ();
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 100, -2);
	gtk_entry_set_visibility (GTK_ENTRY (entry), FALSE);
	app->password_entry = entry;
	if (app->password)
		gtk_entry_set_text(GTK_ENTRY(entry), app->password);

	table = gtk_table_new (1, 2, TRUE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table), 3);
	gtk_table_set_col_spacings (GTK_TABLE (table), 3);

	button = gtk_button_new_with_label (_("Connect"));
	gtk_widget_show (button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_table_attach (GTK_TABLE (table), button, 0, 1, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 5, 0);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (on_login_connect_button_clicked),
			    window);
	gtk_signal_connect (GTK_OBJECT (entry), "activate",
			    GTK_SIGNAL_FUNC (on_login_password_entry_activated),
			    button);

	/* Ȳ   Ϳ focus ش */
	if (!app->save_username)
		gtk_widget_grab_focus(GTK_WIDGET(app->username_entry));
	else if (!app->save_password)
		gtk_widget_grab_focus(GTK_WIDGET(app->password_entry));
	else
		gtk_widget_grab_focus(button);

	button = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_show (button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_table_attach (GTK_TABLE (table), button, 1, 2, 0, 1,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 5, 0);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (on_login_cancel_button_clicked),
			    window);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
			    GTK_SIGNAL_FUNC (on_login_cancel_button_clicked),
		      	    window);

	return window;
}

GtkWidget *alert(const gchar *fmt, ...) {
	static GtkWidget *vbox = NULL;
	va_list arg;
	gchar *message;
	GtkWidget *window;
	GtkWidget *label;
	GtkWidget *hbox;
	GtkWidget *hbuttonbox;
	GtkWidget *button;

	va_start(arg, fmt);
	message = g_strdup_vprintf(fmt, arg);
	va_end(arg);

	if (vbox) {
		label = gtk_label_new(message);
		gtk_widget_show(label);
		gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 5);
		return NULL;
	}
	
	window = gtk_dialog_new();
	gtk_window_set_default_size(GTK_WINDOW(window), 250, 100);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
			    GTK_SIGNAL_FUNC (on_alert_destroy),
			    window);

	hbox = gtk_hbox_new(FALSE, 5);
	gtk_widget_show(hbox);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox), hbox);
	gtk_container_set_border_width(GTK_CONTAINER (hbox), 10);

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox);
	gtk_object_set_user_data(GTK_OBJECT(window), &vbox);
	gtk_container_add(GTK_CONTAINER(hbox), vbox);

	label = gtk_label_new(message);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 5);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area), \
			   hbuttonbox, TRUE, TRUE, 5);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_DEFAULT_STYLE);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox), 80, -2);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);

	button = gtk_button_new_with_label(_("OK"));
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show(button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_widget_grab_focus(button);

	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (on_alert_ok_button_clicked),
			    window);

	gtk_widget_show(window);
	g_free(message);

	return window;
}

GtkWidget *create_pref_general_tab(void) {
	GtkWidget *vbox;
	GtkWidget *vbox2;
	GtkWidget *frame;
	GtkWidget *table;
	GtkWidget *entry;
	GtkWidget *checkbutton;
	GtkWidget *label;
	GtkTooltips *tips;

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	frame = gtk_frame_new (_("User information"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	vbox2 = gtk_vbox_new (FALSE, 10);
	gtk_widget_show (vbox2);
	gtk_container_add (GTK_CONTAINER (frame), vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);

	table = gtk_table_new (3, 3, FALSE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox2), table, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 0);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 5);

	label = gtk_label_new (_("Username:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	entry = gtk_entry_new_with_max_length (20);
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 120, -2);
	if (pref->username)
		gtk_entry_set_text (GTK_ENTRY(entry), pref->username);
	gtk_widget_set_sensitive (entry, pref->save_username);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&(pref->username));

	checkbutton = gtk_check_button_new_with_label (_("Save username"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 0, 1,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->save_username);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_save_username_toggled),
			entry);

	label = gtk_label_new (_("Password:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	entry = gtk_entry_new_with_max_length (20);
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_entry_set_visibility (GTK_ENTRY(entry), FALSE);
	gtk_widget_set_usize (entry, 120, -2);
	if (pref->password)
		gtk_entry_set_text (GTK_ENTRY(entry), pref->password);
	gtk_widget_set_sensitive (entry, pref->save_password);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&(pref->password));

	checkbutton = gtk_check_button_new_with_label (_("Save password"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 1, 2,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->save_password);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_save_password_toggled),
			entry);

	checkbutton = gtk_check_button_new_with_label (_("Auto login"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 3, 2, 3,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->auto_login);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->auto_login);

	frame = gtk_frame_new (_("Server information"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	vbox2 = gtk_vbox_new (FALSE, 10);
	gtk_widget_show (vbox2);
	gtk_container_add (GTK_CONTAINER (frame), vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);

	table = gtk_table_new (3, 3, FALSE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox2), table, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 0);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 5);

	label = gtk_label_new (_("Server:"));
	gtk_widget_show (label);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);

	entry = gtk_entry_new_with_max_length (1024);
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 150, -2);
	gtk_entry_set_text (GTK_ENTRY(entry), pref->soribada_server);
	gtk_widget_set_sensitive (entry, !pref->use_default_server);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&pref->soribada_server);

	checkbutton = gtk_check_button_new_with_label (_("Use default"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->use_default_server);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_default_server_toggled),
			entry);

	label = gtk_label_new (_("Proxy Server:"));
	gtk_widget_show (label);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);

	entry = gtk_entry_new_with_max_length (1024);
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 150, -2);
	if (pref->proxy_server != NULL)
		gtk_entry_set_text (GTK_ENTRY(entry), pref->proxy_server);
	gtk_widget_set_sensitive (entry, pref->use_proxy);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&pref->proxy_server);

	tips = gtk_tooltips_new();
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, \
			_("Write like this \"proxy.foo.bar:8080\""),
			_("(null)"));

	checkbutton = gtk_check_button_new_with_label (_("Use proxy server"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->use_proxy);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_use_proxy_server_toggled),
			entry);

	checkbutton = gtk_check_button_new_with_label (_("Auto check online"));
	gtk_widget_show (checkbutton);
	gtk_box_pack_start (GTK_BOX (vbox2), checkbutton, FALSE, FALSE, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->check_online);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->check_online);

	return vbox;
}

GtkWidget *create_pref_search_tab(void) {
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *frame;
	GtkWidget *table;
	GtkWidget *checkbutton;
	GtkWidget *label;
	GtkObject *spinbutton_adj;
	GtkWidget *spinbutton;
	GtkWidget *vseparator;

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	hbox = gtk_hbox_new (FALSE, 10);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);

	label = gtk_label_new (_("Max no of Search result:"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

	spinbutton_adj = gtk_adjustment_new ((gfloat)pref->maxreplies, \
					0, MAX_SEARCH_RESULT, 10, 100, 100);
	spinbutton = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_adj), 10, 0);
	gtk_widget_show (spinbutton);
	gtk_box_pack_start (GTK_BOX (hbox), spinbutton, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (spinbutton), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_spinbutton_event),
			&pref->maxreplies);

	frame = gtk_frame_new (_("Display item of search result column"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	table = gtk_table_new (5, 3, FALSE);
	gtk_widget_show (table);
	gtk_container_add (GTK_CONTAINER (frame), table);
	gtk_container_set_border_width (GTK_CONTAINER (table), 10);
	gtk_table_set_col_spacings (GTK_TABLE (table), 10);

	checkbutton = gtk_check_button_new_with_label (_("Filename"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_filename);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_filename);

	checkbutton = gtk_check_button_new_with_label (_("Title"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 1, 2,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_title);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_title);

	checkbutton = gtk_check_button_new_with_label (_("Artist"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 2, 3,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_artist);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_artist);

	checkbutton = gtk_check_button_new_with_label (_("Comment"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 3, 4,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_comment);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_comment);

	checkbutton = gtk_check_button_new_with_label (_("Size"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 0, 1,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_size);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_size);

	checkbutton = gtk_check_button_new_with_label (_("Bitrate"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_bitrate);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_bitrate);

	checkbutton = gtk_check_button_new_with_label (_("Time"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 2, 3,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_time);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_time);

	checkbutton = gtk_check_button_new_with_label (_("User"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 3, 4,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_user);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_user);

	checkbutton = gtk_check_button_new_with_label (_("Speed"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 4, 5,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->search_clist_speed);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->search_clist_speed);

	vseparator = gtk_vseparator_new ();
	gtk_widget_show (vseparator);
	gtk_table_attach (GTK_TABLE (table), vseparator, 1, 2, 0, 5,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	return vbox;
}

GtkWidget *create_pref_download_tab(void) {
	GtkWidget *vbox;
	GtkWidget *frame;
	GtkWidget *table;
	GtkWidget *entry;
	GtkWidget *checkbutton;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *vseparator;

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	table = gtk_table_new (2, 3, FALSE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox), table, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 10);

	label = gtk_label_new (_("Download Directory:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	entry = gtk_entry_new ();
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 180, -2);
	gtk_entry_set_text(GTK_ENTRY(entry), pref->download_dir);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&pref->download_dir);

	button = gtk_button_new_with_label (_("Browse"));
	gtk_widget_show (button);
	gtk_table_attach (GTK_TABLE (table), button, 2, 3, 0, 1,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_download_dir_button_clicked),
			entry);

	label = gtk_label_new (_("mp3 player:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	entry = gtk_entry_new ();
	gtk_widget_show (entry);
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 180, -2);
	gtk_entry_set_text(GTK_ENTRY(entry), pref->mp3player);
	gtk_signal_connect (GTK_OBJECT (entry), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_entry_event),
			&pref->mp3player);

	button = gtk_button_new_with_label (_("Browse"));
	gtk_widget_show (button);
	gtk_table_attach (GTK_TABLE (table), button, 2, 3, 1, 2,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_mp3player_button_clicked),
			entry);

	frame = gtk_frame_new (_("Display item of Download column"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	table = gtk_table_new (7, 3, FALSE);
	gtk_widget_show (table);
	gtk_container_add (GTK_CONTAINER (frame), table);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 10);

	label = gtk_label_new (_("Downloading list"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);

	checkbutton = gtk_check_button_new_with_label (_("Filename"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_filename);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_filename);

	checkbutton = gtk_check_button_new_with_label (_("User"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 2, 3,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_user);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_user);

	checkbutton = gtk_check_button_new_with_label (_("Size"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 3, 4,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_size);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_size);

	checkbutton = gtk_check_button_new_with_label (_("Received"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 4, 5,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_received);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_received);

	checkbutton = gtk_check_button_new_with_label (_("Progress"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 5, 6,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_progress);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_progress);

	checkbutton = gtk_check_button_new_with_label (_("Speed"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 0, 1, 6, 7,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloading_clist_speed);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloading_clist_speed);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 1, 2, 0, 1,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	vseparator = gtk_vseparator_new ();
	gtk_widget_show (vseparator);
	gtk_table_attach (GTK_TABLE (table), vseparator, 1, 2, 1, 7,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

	label = gtk_label_new (_("Downloaded list"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 2, 3, 0, 1,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);

	checkbutton = gtk_check_button_new_with_label (_("Filename"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 1, 2,
			(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloaded_clist_filename);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloaded_clist_filename);

	checkbutton = gtk_check_button_new_with_label (_("User"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 2, 3,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloaded_clist_user);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloaded_clist_user);

	checkbutton = gtk_check_button_new_with_label (_("Size"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 3, 4,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloaded_clist_size);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloaded_clist_size);

	checkbutton = gtk_check_button_new_with_label (_("Received"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 4, 5,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloaded_clist_received);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloaded_clist_received);

	checkbutton = gtk_check_button_new_with_label (_("Status"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 5, 6,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->downloaded_clist_status);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->downloaded_clist_status);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 2, 3, 6, 7,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	return vbox;
}

GtkWidget *create_pref_upload_tab(void) {
	GtkWidget *vbox;
	GtkWidget *table;
	GtkWidget *checkbutton;
	GtkObject *spinbutton_adj;
	GtkWidget *spinbutton;
	GtkWidget *label;

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	table = gtk_table_new (3, 3, FALSE);
	gtk_widget_show (table);
	gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 5);

	label = gtk_label_new (_("Port:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 5, 0);

	spinbutton_adj = gtk_adjustment_new (pref->port, 9001, 9993, 16, 16, 16);
	spinbutton = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_adj), 16, 0);
	gtk_widget_show (spinbutton);
	gtk_table_attach (GTK_TABLE (table), spinbutton, 1, 2, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (spinbutton, 100, -2);
	gtk_signal_connect (GTK_OBJECT (spinbutton), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_spinbutton_event),
			&pref->port);

	label = gtk_label_new (_("This option is applied on next run"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 2, 3, 0, 1,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);

	label = gtk_label_new (_("User limit:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 5, 0);

	spinbutton_adj = gtk_adjustment_new (pref->user_limit, 0, 10, 1, 1, 1);
	spinbutton = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_adj), 1, 0);
	gtk_widget_show (spinbutton);
	gtk_table_attach (GTK_TABLE (table), spinbutton, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_signal_connect (GTK_OBJECT (spinbutton), "focus-out-event",
			    GTK_SIGNAL_FUNC (on_preferences_spinbutton_event),
			    &pref->user_limit);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 2, 3, 1, 2,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);

	label = gtk_label_new (_("Bandwidth (kB/s):"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 5, 0);

	spinbutton_adj = gtk_adjustment_new (pref->bandwidth_limit, 10, 1000, 10, 10, 10);
	spinbutton = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_adj), 10, 0);
	gtk_widget_show (spinbutton);
	gtk_table_attach (GTK_TABLE (table), spinbutton, 1, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (spinbutton, 100, -2);
        gtk_widget_set_sensitive(GTK_WIDGET(spinbutton), pref->use_bandwidth_limit);
	gtk_signal_connect (GTK_OBJECT (spinbutton), "focus-out-event",
			GTK_SIGNAL_FUNC (on_preferences_spinbutton_event),
			&pref->bandwidth_limit);

	checkbutton = gtk_check_button_new_with_label (_("Use bandwidth limit"));
	gtk_widget_show (checkbutton);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 2, 3, 2, 3,
			  (GtkAttachOptions) (GTK_FILL),
			  (GtkAttachOptions) (0), 0, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->use_bandwidth_limit);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_use_bandwidth_button_toggled),
			spinbutton);

	checkbutton = gtk_check_button_new_with_label (_("Show query list"));
	gtk_widget_show (checkbutton);
	gtk_box_pack_start (GTK_BOX (vbox), checkbutton, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (checkbutton), 5);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->show_query_list);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->show_query_list);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);

	return vbox;
}

GtkWidget *create_pref_local_tab(void) {
	GtkWidget *vbox;
	GtkWidget *frame;
	GtkWidget *hbox;
	GtkWidget *scrolledwindow;
	GtkWidget *list;
	GtkWidget *listitem;
	GtkWidget *vbuttonbox;
	GtkWidget *button;
	GtkWidget *checkbutton;
	GList *glist;

	vbox = gtk_vbox_new (FALSE, 10);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	frame = gtk_frame_new (_("Local mp3 directory:"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	hbox = gtk_hbox_new (FALSE, 10);
	gtk_widget_show (hbox);
	gtk_container_add (GTK_CONTAINER (frame), hbox);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (hbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	list = gtk_list_new();
	gtk_widget_show (list);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (scrolledwindow), list);

	glist = pref->localmp3_dir;
	while (glist != NULL) {
		listitem = gtk_list_item_new_with_label((gchar *)glist->data);
		gtk_widget_show(listitem);
		gtk_object_set_user_data(GTK_OBJECT(listitem), glist->data);
		gtk_container_add (GTK_CONTAINER (list), listitem);
		glist = glist->next;
	}

	vbuttonbox = gtk_vbutton_box_new ();
	gtk_widget_show (vbuttonbox);
	gtk_box_pack_start (GTK_BOX (hbox), vbuttonbox, FALSE, FALSE, 5);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox), GTK_BUTTONBOX_START);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (vbuttonbox), 70, -2);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (vbuttonbox), 10, 0);

	button = gtk_button_new_with_label (_("Add"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (vbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_local_mp3_dir_add_button_clicked),
			list);

	button = gtk_button_new_with_label (_("Delete"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (vbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_local_mp3_dir_delete_button_clicked),
			list);

	checkbutton = gtk_check_button_new_with_label (_("Scan sub-directories"));
	gtk_widget_show (checkbutton);
	gtk_box_pack_start (GTK_BOX (vbox), checkbutton, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (checkbutton), 5);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), \
				      pref->scan_sub_dirs);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			GTK_SIGNAL_FUNC (on_check_button_toggled),
			&pref->scan_sub_dirs);

	return vbox;
}

char *check_xpm[] = {
/* columns rows colors chars-per-pixel */
"16 16 26 1",
"  c Gray0",
". c #5a0000",
"X c #640000",
"o c #710000",
"O c #7a0000",
"+ c #7c0000",
"@ c Gray40",
"# c #860000",
"$ c #950303",
"% c #9a0000",
"& c #8d2b2b",
"* c #942c2c",
"= c #ad1212",
"- c #a62e2e",
"; c #bf3232",
": c #d40000",
"> c #dc0404",
", c #e30707",
"< c #e50000",
"1 c #e70f0f",
"2 c #eb0e0e",
"3 c #f50c0c",
"4 c #f41515",
"5 c #f53a3a",
"6 c #f83939",
"7 c None",
/* pixels */
"7777777777777777",
"7777777777777777",
"7@@@@@@@@@@@@@@7",
"7@777777777777@7",
"7@777777777777@7",
"7@777777777&47@7",
"7@77777777*1%7@7",
"7@7777777-2#77@7",
"7@77=777;,O777@7",
"7@77$356>X7777@7",
"7@777+<:.77777@7",
"7@7777o7777777@7",
"7@777777777777@7",
"7@@@@@@@@@@@@@@7",
"7777777777777777",
"7777777777777777"
};

char *uncheck_xpm[] = {
/* columns rows colors chars-per-pixel */
"16 16 3 1",
"  c Gray40",
". c Gray100",
"X c None",
/* pixels */
"XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXX",
"X              X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X XXXXXXXXXXXX X",
"X              X",
"XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXX"
};

GdkPixmap *check;
GdkBitmap *checkmask;
GdkPixmap *uncheck;
GdkBitmap *uncheckmask;

GtkWidget *create_pref_sound_tab(void) {
	GtkWidget *vbox;
	GtkWidget *vbox2;
	GtkWidget *hbox;
	GtkWidget *optionmenu;
	GtkWidget *menu;
	GtkWidget *menuitem;
	GtkWidget *clist;
	GtkWidget *label;
	GtkWidget *scrolledwindow;
	GtkWidget *hbuttonbox;
	GtkWidget *button;
	gint row;
	gchar *text[3];

	vbox = gtk_vbox_new (FALSE, 3);
	gtk_widget_show (vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 3);

	hbox = gtk_hbox_new (FALSE, 3);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

	label = gtk_label_new(_("Sound Device:"));
	gtk_widget_show (label);
	gtk_misc_set_alignment (GTK_MISC (label), 0.2, 0.5);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 10);

	vbox2 = gtk_vbox_new (FALSE, 0);

	optionmenu = gtk_option_menu_new ();
	gtk_widget_show (optionmenu);
	gtk_box_pack_start (GTK_BOX (hbox), optionmenu, FALSE, FALSE, 0);

	menu = gtk_menu_new ();
	menuitem = gtk_menu_item_new_with_label (_("No Sound"));
	gtk_widget_show (menuitem);
	gtk_menu_append (GTK_MENU (menu), menuitem);
	gtk_object_set_user_data(GTK_OBJECT(menuitem), GINT_TO_POINTER(NO_SOUND));
	gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			GTK_SIGNAL_FUNC (on_sound_device_menu_activated),
			vbox2);
	menuitem = gtk_menu_item_new_with_label (_("Beep"));
	gtk_widget_show (menuitem);
	gtk_menu_append (GTK_MENU (menu), menuitem);
	gtk_object_set_user_data(GTK_OBJECT(menuitem), GINT_TO_POINTER(BEEP_SOUND));
	gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			GTK_SIGNAL_FUNC (on_sound_device_menu_activated),
			vbox2);
#ifdef HAVE_ESD
	menuitem = gtk_menu_item_new_with_label (_("ESD"));
	gtk_widget_show (menuitem);
	gtk_menu_append (GTK_MENU (menu), menuitem);
	gtk_object_set_user_data(GTK_OBJECT(menuitem), GINT_TO_POINTER(ESD_SOUND));
	gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			GTK_SIGNAL_FUNC (on_sound_device_menu_activated),
			vbox2);
#endif
	gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu), menu);
	/* ⼭ history index sound_device   
	 *  ɼ ִ app sound_device enum  */
	gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu), \
					pref->sound_device);

	gtk_widget_show (vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 0);
	gtk_box_pack_start (GTK_BOX (vbox), vbox2, TRUE, TRUE, 0);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (3);
	gtk_widget_show (clist);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_column_titles_show (GTK_CLIST (clist));
	gtk_signal_connect (GTK_OBJECT (clist), "button-press-event",
			GTK_SIGNAL_FUNC (on_sound_event_clist_button_press),
			clist);

	label = gtk_label_new (_("Use"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 30);
	gtk_clist_set_column_justification (GTK_CLIST (clist), 0, \
					GTK_JUSTIFY_CENTER);

	label = gtk_label_new (_("Event"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 120);

	label = gtk_label_new (_("Sound File"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);
	//gtk_clist_set_column_width (GTK_CLIST (clist), 2, 50);
	gtk_clist_set_column_auto_resize (GTK_CLIST (clist), 2, TRUE);

	check = gdk_pixmap_create_from_xpm_d(GTK_WIDGET(app->window)->window, \
					&checkmask, \
					&GTK_WIDGET(clist)->style->white, \
					check_xpm);
	uncheck = gdk_pixmap_create_from_xpm_d(GTK_WIDGET(app->window)->window, \
					&uncheckmask, \
					&GTK_WIDGET(clist)->style->white, \
					uncheck_xpm);

	text[0] = NULL;
	text[1] = _("search completed");
	text[2] = pref->sound_on_search;
	row = gtk_clist_append (GTK_CLIST(clist), text);
	gtk_clist_set_row_data (GTK_CLIST(clist), row, &pref->use_sound_on_search);
	if (pref->use_sound_on_search)
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, check, checkmask);
	else
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, uncheck, uncheckmask);

	text[0] = NULL;
	text[1] = _("download completed");
	text[2] = pref->sound_on_down;
	row = gtk_clist_append (GTK_CLIST(clist), text);
	gtk_clist_set_row_data (GTK_CLIST(clist), row, &pref->use_sound_on_down);
	if (pref->use_sound_on_down)
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, check, checkmask);
	else
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, uncheck, uncheckmask);


	text[0] = NULL;
	text[1] = _("message received");
	text[2] = pref->sound_on_message;
	row = gtk_clist_append (GTK_CLIST(clist), text);
	gtk_clist_set_row_data (GTK_CLIST(clist), row, &pref->use_sound_on_message);
	if (pref->use_sound_on_message)
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, check, checkmask);
	else
		gtk_clist_set_pixmap(GTK_CLIST(clist), row, 0, uncheck, uncheckmask);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox), 3);
	gtk_box_pack_start (GTK_BOX (vbox2), hbuttonbox, FALSE, FALSE, 0);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox), 70, -2);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), \
					GTK_BUTTONBOX_SPREAD);
	gtk_signal_connect (GTK_OBJECT (clist), "select-row",
			GTK_SIGNAL_FUNC (on_sound_event_clist_selected),
			hbuttonbox);
	gtk_signal_connect (GTK_OBJECT (clist), "unselect-row",
			GTK_SIGNAL_FUNC (on_sound_event_clist_unselected),
			hbuttonbox);

	button = gtk_button_new_with_label (_("Test"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_sound_test_button_clicked),
			clist);

	button = gtk_button_new_with_label (_("Modify"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_sound_modify_button_clicked),
			clist);

	if (pref->sound_device == NO_SOUND)
		gtk_widget_set_sensitive(vbox2, FALSE);

	gtk_widget_set_sensitive(hbuttonbox, FALSE);

	return vbox;
}

GtkWidget* create_preference_window (void) {
	GtkWidget *preference_window;
	GtkWidget *notebook;
	GtkWidget *vbox;
	GtkWidget *tab;
	GtkWidget *button;
	GtkWidget *label;
	GtkWidget *hseparator;
	GtkWidget *hbuttonbox;

	preference_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (preference_window), _("Preference"));

	vbox = gtk_vbox_new (FALSE, 5);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (preference_window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	notebook = gtk_notebook_new ();
	gtk_widget_show (notebook);
	gtk_notebook_set_homogeneous_tabs(GTK_NOTEBOOK(notebook), TRUE);
	gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);

	/* general tab */
	tab = create_pref_general_tab();
	label = gtk_label_new (_("General"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* search tab */
	tab = create_pref_search_tab();
	label = gtk_label_new (_("Search"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* download tab */
	tab = create_pref_download_tab();
	label = gtk_label_new (_("Download"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* upload tab */
	tab = create_pref_upload_tab();
	label = gtk_label_new (_("Upload"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* local file tab */
	tab = create_pref_local_tab();
	label = gtk_label_new (_("Local files"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	/* sound tab */
	tab = create_pref_sound_tab();
  	label = gtk_label_new (_("Sound"));
	gtk_widget_show (label);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), tab, label);

	hseparator = gtk_hseparator_new ();
	gtk_widget_show (hseparator);
	gtk_box_pack_start (GTK_BOX (vbox), hseparator, FALSE, TRUE, 0);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, FALSE, FALSE, 5);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_END);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 10, 0);

	button = gtk_button_new_with_label (_("OK"));
	gtk_widget_show (button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_preference_ok_button_clicked),
			preference_window);

	button = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_show (button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (on_preference_cancel_button_clicked),
			preference_window);
	gtk_widget_grab_focus(button);

	gtk_signal_connect (GTK_OBJECT (preference_window), "destroy",
			GTK_SIGNAL_FUNC (on_preference_window_destroy),
			preference_window);

	return preference_window;
}

GtkWidget* create_download_as_dialog (const gchar *filename) {
	GtkWidget *fileselection;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	gchar *path;

	fileselection = gtk_file_selection_new (_("Download as ..."));
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	path = g_strdup_printf("%s/%s", app->download_dir, filename);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
					path);
	g_free(path);

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
		      GTK_SIGNAL_FUNC (on_download_as_ok_clicked),
		      fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (on_download_as_cancel_clicked),
		      fileselection);

	return fileselection;
}

GtkWidget* create_select_download_dir_dialog (gpointer data) {
	GtkWidget *fileselection;
	GtkWidget *file_list;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	gchar *path;

	fileselection = gtk_file_selection_new (_("Select download directory"));
	gtk_object_set_user_data(GTK_OBJECT(fileselection), data);
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	file_list = GTK_FILE_SELECTION (fileselection)->file_list;
	gtk_widget_set_sensitive(file_list, FALSE);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	path = g_strdup_printf("%s/", gtk_entry_get_text(GTK_ENTRY(data)));
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
					path);
	g_free(path);

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_download_dir_dlg_ok),
			    fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_download_dir_dlg_cancel),
			    fileselection);

	return fileselection;
}

GtkWidget* create_select_mp3player_dialog (gpointer data) {
	GtkWidget *fileselection;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	gchar *path;

	fileselection = gtk_file_selection_new (_("Select mp3 player"));
	gtk_object_set_user_data(GTK_OBJECT(fileselection), data);
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	path = g_strdup_printf("%s", gtk_entry_get_text(GTK_ENTRY(data)));
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
					path);
	g_free(path);

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_mp3player_dlg_ok),
			    fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_mp3player_dlg_cancel),
			    fileselection);

	return fileselection;
}

/* data preference 쿡    ִ gtk_list̴ */
GtkWidget* create_select_local_mp3_dir_dialog (gpointer data) {
	GtkWidget *fileselection;
	GtkWidget *file_list;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	GList *list;

	fileselection = gtk_file_selection_new (_("Select local mp3 directory"));
	gtk_object_set_user_data(GTK_OBJECT(fileselection), data);
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	file_list = GTK_FILE_SELECTION (fileselection)->file_list;
	gtk_widget_set_sensitive(file_list, FALSE);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	list = pref->localmp3_dir;
	if (list != NULL) {
		list = g_list_last(list);
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
						(gchar *)list->data);
	}

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_local_mp3_dir_dlg_ok),
			    fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_local_mp3_dir_dlg_cancel),
			    fileselection);

	return fileselection;
}

GtkWidget* create_file_add_dialog (const gchar *dir) {
	GtkWidget *fileselection;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	gchar *path;

	fileselection = gtk_file_selection_new (_("Add file"));
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	path = g_strdup_printf("%s/", dir);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
					path);
	g_free(path);

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (on_file_add_dlg_ok),
			    fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (on_file_add_dlg_cancel),
			    fileselection);

	return fileselection;
}


GtkWidget* create_pixmap (GtkWidget *widget) {
	GdkColormap *colormap;
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;
	GtkWidget *pixmap;

	colormap = gtk_widget_get_colormap (widget);
	gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask,
						   NULL, soribada_pixmap);
	pixmap = gtk_pixmap_new (gdkpixmap, mask);
	gdk_pixmap_unref (gdkpixmap);
	gdk_bitmap_unref (mask);

	return pixmap;
}

GtkWidget* create_about_window (void) {
	static GtkWidget *window = NULL;
	GtkWidget *vbox;
	GtkWidget *frame;
	GtkWidget *vbox2;
	GtkWidget *pixmap;
	GtkWidget *label;
	GtkWidget *hseparator;
	GtkWidget *hbox;
	GtkWidget *button;
	gchar *str;

	if (window != NULL) {
		gdk_window_show(window->window);
		gdk_window_raise(window->window);
		return window;
	}

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), _("About"));

	vbox = gtk_vbox_new (FALSE, 3);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	str = g_strdup_printf(_("Soribada %s"), VERSION);
	frame = gtk_frame_new (str);
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

	vbox2 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox2);
	gtk_container_add (GTK_CONTAINER (frame), vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);

	pixmap = create_pixmap (window);
	gtk_widget_show (pixmap);
	gtk_box_pack_start (GTK_BOX (vbox2), pixmap, TRUE, TRUE, 0);

	label = gtk_label_new (str);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);

	label = gtk_label_new (_("Copyright (c) 2002 by Choe Hwanjin\nkrisna@kldp.org"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);

	label = gtk_label_new (_("http://soribada.kldp.org/"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);

	label = gtk_label_new (_("Released under the GNU Generel Public License"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);

	hseparator = gtk_hseparator_new ();
	gtk_widget_show (hseparator);
	gtk_box_pack_start (GTK_BOX (vbox), hseparator, FALSE, FALSE, 0);

	hbox = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);

	button = gtk_button_new_with_label (_("OK"));
	gtk_widget_show (button);
	gtk_widget_set_usize (button, 80, -2);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
	gtk_widget_grab_focus(button);

	label = gtk_label_new ("");
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);

	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (on_about_button_clicked),
		      window);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroyed),
		      &window);
	g_free(str);

	gtk_widget_show(window);
	return window;
}

GtkWidget* create_file_info_window (void *data) {
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *hbox2;
	GtkWidget *entry;
	GtkWidget *frame;
	GtkWidget *table;
	GtkWidget *checkbutton;
	GtkWidget *label;
	GtkWidget *combo;
	GtkWidget *combo_entry;
	GtkWidget *vbox2;
	GtkWidget *hbuttonbox;
	GtkWidget *button;
	GtkWidget *item;
	int i;
	struct mp3info info;
	gchar buf[64];
	File_info *file_info = (File_info *)data;

	if (mp3_get_info(file_info->path, &info) < 0)
		return NULL;
	file_info->use_id3_tag = info.id3tag;

	window = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (window), "file_info", file_info);
	gtk_window_set_title (GTK_WINDOW (window), _("File information"));

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	hbox = gtk_hbox_new (FALSE, 5);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);

	label = gtk_label_new (_("File name:"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

	entry = gtk_entry_new_with_max_length (1024);
	file_info->filename = entry;
	gtk_widget_show (entry);
	gtk_entry_set_text(GTK_ENTRY(entry), g_basename(file_info->path));
	gtk_box_pack_start (GTK_BOX (hbox), entry, TRUE, TRUE, 0);

	hbox = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);

	frame = gtk_frame_new (_("ID3v1 tag"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frame), 5);

	table = gtk_table_new (7, 2, FALSE);
	gtk_widget_show (table);
	gtk_container_add (GTK_CONTAINER (frame), table);
	gtk_container_set_border_width (GTK_CONTAINER (table), 5);
	gtk_table_set_row_spacings (GTK_TABLE (table), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table), 5);

	checkbutton = gtk_check_button_new_with_label (_("Use ID3v1 tag"));
	gtk_widget_show (checkbutton);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton),
				     file_info->use_id3_tag);
	gtk_table_attach (GTK_TABLE (table), checkbutton, 1, 2, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_signal_connect (GTK_OBJECT (checkbutton), "toggled",
			    GTK_SIGNAL_FUNC(on_use_id3_tag_button_toggled),
			    (gpointer)file_info);

	label = gtk_label_new (_("Title:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	entry = gtk_entry_new_with_max_length (30);
	file_info->title = entry;
	gtk_widget_show (entry);
	gtk_entry_set_text(GTK_ENTRY(entry), g_strchomp(info.title));
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 200, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Artist:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	entry = gtk_entry_new_with_max_length (30);
	file_info->artist = entry;
	gtk_widget_show (entry);
	gtk_entry_set_text(GTK_ENTRY(entry), g_strchomp(info.artist));
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 200, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Album:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	entry = gtk_entry_new_with_max_length (30);
	file_info->album = entry;
	gtk_widget_show (entry);
	gtk_entry_set_text(GTK_ENTRY(entry), g_strchomp(info.album));
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 200, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Comment:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	entry = gtk_entry_new_with_max_length (30);
	file_info->comment = entry;
	gtk_widget_show (entry);
	gtk_entry_set_text(GTK_ENTRY(entry), g_strchomp(info.comment));
	gtk_table_attach (GTK_TABLE (table), entry, 1, 2, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_usize (entry, 200, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Year:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	hbox2 = gtk_hbox_new (FALSE, 5);
	gtk_widget_show (hbox2);
	gtk_table_attach (GTK_TABLE (table), hbox2, 1, 2, 5, 6,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

	entry = gtk_entry_new_with_max_length (4);
	gtk_widget_show (entry);
	file_info->year = entry;
	gtk_entry_set_text(GTK_ENTRY(entry), info.year);
	gtk_box_pack_start (GTK_BOX (hbox2), entry, TRUE, TRUE, 0);
	gtk_widget_set_usize (entry, 50, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Track:"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox2), label, TRUE, TRUE, 0);

	entry = gtk_entry_new_with_max_length (4);
	gtk_widget_show (entry);
	file_info->track = entry;
	if (!file_info->use_id3_tag || info.track < 0)
		buf[0] = '\0';
	else
		g_snprintf(buf, sizeof(buf), "%d", info.track);
	gtk_entry_set_text(GTK_ENTRY(entry), buf);
	gtk_box_pack_start (GTK_BOX (hbox2), entry, TRUE, TRUE, 0);
	gtk_widget_set_usize (entry, 50, -2);
	gtk_widget_set_sensitive(entry, file_info->use_id3_tag);

	label = gtk_label_new (_("Genre:"));
	gtk_widget_show (label);
	gtk_table_attach (GTK_TABLE (table), label, 0, 1, 6, 7,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 1, 0.5);

	combo = gtk_combo_new ();
	file_info->genre = combo;
	gtk_widget_show (combo);
	gtk_table_attach (GTK_TABLE (table), combo, 1, 2, 6, 7,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_widget_set_sensitive(combo, file_info->use_id3_tag);

	combo_entry = GTK_COMBO (combo)->entry;
	gtk_widget_show (combo_entry);
	gtk_widget_set_usize (combo_entry, 200, -2);
	gtk_entry_set_editable (GTK_ENTRY (combo_entry), FALSE);
	item = gtk_list_item_new_with_label("");
	gtk_widget_show(item);
	gtk_object_set_data(GTK_OBJECT(item), "genre", (gpointer)-1);
	gtk_container_add(GTK_CONTAINER(GTK_COMBO(combo)->list), item);
	for (i = 0; genre_tbl[i] != NULL; i++) {
		item = gtk_list_item_new_with_label(genre_tbl[i]);
		gtk_widget_show(item);
		gtk_object_set_data(GTK_OBJECT(item), "genre", (gpointer)i);
		gtk_container_add(GTK_CONTAINER(GTK_COMBO(combo)->list), item);
		if (info.genre == i)
			gtk_list_select_item(GTK_LIST(GTK_COMBO(combo)->list), \
					     i + 1);
	}
	if (info.genre < 0)
		gtk_list_select_item(GTK_LIST(GTK_COMBO(combo)->list), 0);
	file_info->genre_no = info.genre;
	gtk_signal_connect (GTK_OBJECT (GTK_COMBO(combo)->list), "select-child",
			    GTK_SIGNAL_FUNC (on_file_info_genre_selected),
			    file_info);

	frame = gtk_frame_new (_("MPEG info"));
	gtk_widget_show (frame);
	gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frame), 5);

	vbox2 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox2);
	gtk_container_add (GTK_CONTAINER (frame), vbox2);
	gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);

	g_snprintf(buf, sizeof(buf), "MPEG %s, Layer %s",
				     mp3_get_version_str(&info),
				     mp3_get_layer_str(&info));
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	if (info.bitrate < 0)
		g_snprintf(buf, sizeof(buf), "Bitrate: VBR");
	else
		g_snprintf(buf, sizeof(buf), "Bitrate: %d kbit/s",info.bitrate);
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	g_snprintf(buf, sizeof(buf), "Frequency: %d Hz", info.frequency);
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	g_snprintf(buf, sizeof(buf), "Mode: %s", mp3_get_mode_str(&info));
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	if (info.copyright)
		g_snprintf(buf, sizeof(buf), "Copyright: Yes");
	else
		g_snprintf(buf, sizeof(buf), "Copyright: No");
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	if (info.original)
		g_snprintf(buf, sizeof(buf), "Original: Yes");
	else
		g_snprintf(buf, sizeof(buf), "Original: No");
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	g_snprintf(buf, sizeof(buf), "Time: %d:%02d (%d sec)", \
				     info.seconds / 60, info.seconds % 60,
				     info.seconds);
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	g_snprintf(buf, sizeof(buf), "File size: %d bytes", \
				     get_file_size(file_info->path));
	label = gtk_label_new (buf);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, TRUE, TRUE, 0);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_END);
	gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox), 10);

	button = gtk_button_new_with_label (_("Save"));
	gtk_widget_show (button);
	file_info->save_button = button;
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_widget_set_sensitive (button, FALSE);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT (button), "clicked",
			   GTK_SIGNAL_FUNC (on_file_info_save_button_clicked),
			   file_info);
	gtk_signal_connect(GTK_OBJECT (file_info->title), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (file_info->artist), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (file_info->album), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (file_info->comment), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (file_info->year), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (file_info->track), "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);
	gtk_signal_connect(GTK_OBJECT (GTK_COMBO(file_info->genre)->entry), \
			   "changed",
			   GTK_SIGNAL_FUNC (on_file_info_entry_changed),
			   button);

	button = gtk_button_new_with_label (_("Rename"));
	gtk_widget_show (button);
	gtk_widget_set_sensitive(button, FALSE);
	file_info->rename_button = button;
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (on_file_info_rename_button_clicked),
		      file_info);
	gtk_signal_connect (GTK_OBJECT (file_info->filename), "changed",
		      GTK_SIGNAL_FUNC (on_file_info_entry_changed),
		      button);
	gtk_signal_connect (GTK_OBJECT (file_info->filename), "activate",
		      GTK_SIGNAL_FUNC (on_file_info_rename_button_clicked),
		      file_info);

	button = gtk_button_new_with_label (_("Close"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (on_file_info_close_button_clicked),
		      window);
	gtk_widget_grab_focus(button);

	return window;
}

GtkWidget *create_message_clist_menu(GtkWidget *widget) {
	GtkWidget *menu;
	GtkWidget *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label(_("Reply"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_message_clist_menu_reply_activate),
			(gpointer)widget);

	menuitem = gtk_menu_item_new_with_label(_("Delete"));
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect_object(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(on_message_clist_menu_delete_activate),
			(gpointer)widget);

	return menu;
}

GtkWidget* create_message_window (void *data) {
	GtkWidget *message_window;
	GtkWidget *hpaned;
	GtkWidget *scrolledwindow;
	GtkWidget *clist;
	GtkWidget *label;
	GtkWidget *vbox;
	GtkWidget *text;
	GtkWidget *hbuttonbox;
	GtkWidget *button;
	GtkWidget *menu;
	char *arg[3];
	char buf[64];
	int row;
	int selectedrow = 0;
	GList *list;
	Messageitem *mitem;
	Messageitem *msgitem = (Messageitem *)data;

	message_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (message_window), \
			      _("Received Messages"));
	gtk_widget_set_usize (message_window, 500, 250);

	hpaned = gtk_hpaned_new ();
	gtk_widget_show (hpaned);
	gtk_container_add (GTK_CONTAINER (message_window), hpaned);
	gtk_paned_set_position (GTK_PANED (hpaned), 200);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_paned_pack1 (GTK_PANED (hpaned), scrolledwindow, FALSE, TRUE);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	clist = gtk_clist_new (3);
	gtk_widget_show (clist);
	app->message_clist = clist;
	gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
	gtk_clist_set_column_width (GTK_CLIST (clist), 0, 20);
	gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
	gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);
	gtk_clist_column_titles_show (GTK_CLIST (clist));

	label = gtk_label_new (_("St"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label);
	gtk_clist_set_column_visibility(GTK_CLIST(clist), 0, FALSE);

	label = gtk_label_new (_("User"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label);

	label = gtk_label_new (_("Time"));
	gtk_widget_show (label);
	gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label);

	menu = create_message_clist_menu(clist);
	gtk_signal_connect (GTK_OBJECT (clist), "event",
		      GTK_SIGNAL_FUNC (on_clist_button_press),
		      menu);

	list = app->messages;
	while (list != NULL) {
		mitem = (Messageitem *)list->data;
		strftime(buf, sizeof(buf), "%H:%M:%S", localtime(&mitem->time));
		arg[0] = NULL;
		arg[1] = mitem->msg->username;
		arg[2] = buf;
		row = gtk_clist_append(GTK_CLIST(clist), arg);
		gtk_clist_set_row_data(GTK_CLIST(clist), row, mitem);
		if (mitem == msgitem)
			selectedrow = row;
		list = list->next;
	}

	vbox = gtk_vbox_new (FALSE, 3);
	gtk_widget_show (vbox);
	gtk_paned_pack2 (GTK_PANED (hpaned), vbox, TRUE, TRUE);

	label = gtk_label_new (_("Message received"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label), 0.1, 0.5);
	gtk_misc_set_padding (GTK_MISC (label), 0, 2);

	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow);
	gtk_widget_set_usize (scrolledwindow, 250, -2);
	gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow), 1);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), \
					GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

	text = gtk_text_new (NULL, NULL);
	gtk_widget_show (text);
	app->message_text = text;
	set_message_text(text, msgitem);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), text);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start (GTK_BOX (vbox), hbuttonbox, FALSE, TRUE, 0);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), \
				   GTK_BUTTONBOX_END);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox), 5);

	button = gtk_button_new_with_label (_("Close"));
	gtk_widget_show (button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (on_message_window_close_button_clicked),
		      message_window);
	gtk_widget_grab_focus(button);

	gtk_signal_connect (GTK_OBJECT (clist), "select-row",
		      GTK_SIGNAL_FUNC (on_message_clist_select_row),
		      text);

	gtk_clist_select_row(GTK_CLIST(clist), selectedrow, 0);

	return message_window;
}

GtkWidget *create_send_message_dialog(void *data) {
	GtkWidget *window;
	GtkWidget *label;
	GtkWidget *vbox;
	GtkWidget *text;
	GtkWidget *hbuttonbox;
	GtkWidget *button;
	gchar *title;
	Messageitem *mitem = (Messageitem *)data;

	title = g_strdup_printf(_("Message to %s:"), mitem->msg->username);
	window = gtk_dialog_new();
	gtk_object_set_data(GTK_OBJECT(window), "Messageitem", mitem);
	gtk_window_set_default_size(GTK_WINDOW(window), 250, 250);
	gtk_window_set_title(GTK_WINDOW(window), title);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy),
			    window);

	vbox = GTK_DIALOG(window)->vbox;
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);

	label = gtk_label_new(title);
	gtk_widget_show(label);
	gtk_misc_set_alignment (GTK_MISC (label), 0.1, 0.5);
	gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 3);
	g_free(title);

	text = gtk_text_new(NULL, NULL);
	gtk_widget_show(text);
	gtk_text_set_editable(GTK_TEXT(text), TRUE);
	gtk_box_pack_start(GTK_BOX(vbox), text, TRUE, TRUE, 3);
	gtk_object_set_data(GTK_OBJECT(window), "Text", text);

	hbuttonbox = gtk_hbutton_box_new ();
	gtk_widget_show (hbuttonbox);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area), \
			   hbuttonbox, TRUE, TRUE, 0);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), \
				   GTK_BUTTONBOX_SPREAD);
	gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox), 80, -2);
	gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox), 0, 0);

	button = gtk_button_new_with_label(_("Send"));
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show(button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_widget_grab_focus(button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (on_message_send_button_clicked),
			    window);

	button = gtk_button_new_with_label(_("Close"));
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_show(button);
	gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (on_message_close_button_clicked),
			    window);

	return window;
}

GtkWidget* create_select_sound_dialog (gpointer data) {
	GtkWidget *fileselection;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	gint row;
	gchar *path;

        if (GTK_CLIST(data)->selection == NULL) 
	                return NULL;

	row = GPOINTER_TO_INT(GTK_CLIST(data)->selection->data);

	fileselection = gtk_file_selection_new (_("Select wave file"));
	gtk_object_set_user_data(GTK_OBJECT(fileselection), data);
	gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

	ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
	gtk_widget_show (ok_button);
	GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

	cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
	gtk_widget_show (cancel_button);
	GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

	if (gtk_clist_get_text(GTK_CLIST(data), row, 2, &path) == 1) {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
							path);
	} else {
		path = g_strconcat(SOUNDDIR, "/", NULL);
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection), \
							path);
		g_free(path);
	}

	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_sound_dlg_ok),
			    fileselection);
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (on_select_sound_dlg_cancel),
			    fileselection);

	return fileselection;
}

