/* SoriBada - compatible client with windows soribada
 * Copyright (C) 2002 Choe Hwanjin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __MP3_H_
#define __MP3_H_

#ifndef TRUE
	#define TRUE 1
#endif
#ifndef FALSE
	#define FALSE 0
#endif

struct mp3info {
	int version;		/* index of version_tbl */
	int layer;		/* index of layer_tbl */
	int bitrate;
	int frequency;
	int padding;		/* padding bit */
	int mode;		/* Channel Mode */
	int mode_ext;
	int copyright;
	int original;
	int nframes;		/* total no. of frames */
	int seconds;		/* length of song (second) */
	int size;		/* file size */
	int xing;		/* xing flag : vbr */

	int id3tag;
	char title[31];
	char artist[31];
	char album[31];
	char year[5];
	char comment[31];
	int track;
	int genre;
};

extern const char *genre_tbl[];

int mp3_get_info(const char *filename, struct mp3info *info);
const char *mp3_get_version_str(struct mp3info *info);
const char *mp3_get_layer_str(struct mp3info *info);
const char *mp3_get_mode_str(struct mp3info *info);
const char *mp3_get_genre_str(struct mp3info *info);

int mp3_write_id3tag(const char *filename, const char *title, \
					   const char *artist, \
					   const char *album, \
					   const char *comment, \
					   const char *year, \
					   int track, \
					   int genre);
int mp3_remove_id3tag(const char *filename);

#endif /* __MP3_H_ */
