/* SoriBada - compatible client with windows soribada
 * Copyright (C) 2002 Choe Hwanjin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "config.h"

#include <stdio.h>
#include <signal.h>
#include <sys/wait.h>

#include "soribada.h"
#include "core.h"
#include "interface.h"

GList *create_local_mp3db(GList *list, char *dirname);

Application *app;
Preferences *pref;

/* soribada    ʱȭ Ѵ */
void soribada_init(void) {
	int i;

	app = (Application *)xmalloc(sizeof(Application));

	/* ⺻   */
	load_default_value();

	/* conf file  о  */
	load_conf_file();

	/* mp3  о */
	app->mp3_list = mp3db_list_load_from_file(app->mp3_list_file);

	/* online list ʱȭ */
	app->nonlines = 0;
	for (i = 0; i < MAX_ONLINES; i++)
		app->onlines[i] = (struct node *)xmalloc(sizeof (struct node));

	/* ˻  ϴ struct */
	app->query_id = 0;
	app->replies = (MP3 **)xmalloc(sizeof(MP3 *) * app->maxreplies);
	for (i = 0; i < app->maxreplies; i++)
		app->replies[i] = NULL;

	/* downloadϴ item table */
	app->downloads = NULL;
	app->download_queue = NULL;

	/* messages */
	app->messages = NULL;

	app->is_login = FALSE;
	app->quit_upload = FALSE;
	app->stop_search = TRUE;
	app->search_in_result = FALSE;
	app->redraw_search_clist = FALSE;
	app->online_list_updated = FALSE;

	app->pl = sori_protocol_new(app->soribada_server, app->port);

	app->listen_channel = NULL;
	app->service_channel = NULL;
	app->message_channel = NULL;
	app->mp3playerpid = -1;

	app->message_window = NULL;

	pref = NULL;
}

void wait_for_child(int signum) {
	wait(NULL);
	signal(SIGCHLD, &wait_for_child);
}

int main(int argc, char *argv[]) {
	GtkWidget *window;

#ifdef ENABLE_NLS
	bindtextdomain(PACKAGE, LOCALE);
	textdomain(PACKAGE);
#endif
	gtk_set_locale();

	signal(SIGPIPE, SIG_IGN);
	signal(SIGCHLD, &wait_for_child);

	gtk_init(&argc, &argv);
	soribada_init();

	window = create_window();
	gtk_widget_show(window);

	do_auto_login();

	if (!app->auto_login && !app->is_login) {
		GtkWidget *login_window = create_login_window();
		gtk_widget_show(login_window);
	}

	gtk_main();

	return 0;
}
